import { Component, Inject, OnInit } from "@angular/core";
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

export interface DialogData {

  title: string;
  message: string;
  model: any;
  template: string;

}

@Component({
  selector: 'simple-dialog',
  templateUrl: './dialog.component.html',
  styleUrls: ['./dialog.component.css']
})


export class DialogComponent implements OnInit {

  constructor(
    public dialogRef: MatDialogRef<DialogComponent>,
    @Inject(MAT_DIALOG_DATA) public data: DialogData
  ) { }

  public aHeaderList: any;

  ngOnDestroy() {
    setTimeout(() => {
      this.dialogRef ? this.dialogRef.close() : null;
    }, 100)
  }

  ngOnInit() {
    console.log(this.data)
    if (this.data.template == 'SNM056S') {
      this.aHeaderList = this.GenerateHeader()
    }
  }

  onNoClick(): void {
    this.dialogRef.close();
  }

  GenerateHeader() {
    let NumberHeader = [];
    for (let i = 1; i < 32; i++) {
      let newint = i.toString().length < 2 ? 0 + '' + i : i
      NumberHeader.push({ FIELD: 'DATE_STATUS_' + newint, TITLE: i })
    }
    return NumberHeader;
  }

  GetMonthText(NumberOfMonth: any) {

    let MonthList = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]

    return MonthList[NumberOfMonth - 1];

  }

}
