import { Component, OnInit } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Globals } from 'src/app/core/global';
import { Router } from '@angular/router';

@Component({
  selector: 'menu-list',
  templateUrl: './menu-list.component.html',
  styleUrls: ['./menu-list.component.css']
})
export class MenuListComponent implements OnInit {
  public menus: Array<any> = [];

  constructor(
    private http: HttpService,
    private global: Globals,
    private router: Router
  ) { }

  ngOnInit(): void { 
    this.getSystemMenuList();
  }

  getSystemMenuList() {
    this.http.get("System", "GetSystemMenu")
      .subscribe(result => {
        this.menus = result;
        //console.log('this.menus', this.menus)
      })
  }
  
  menuDetailFilter(headerId: number) {
    return this.menus.filter((v) => v.HEADER_ID === headerId);
  }

  menuHeaderFilter() {
    return this.menus.filter((v, i, s) => this.global.findUnique(v, i, s, "HEADER_ID"));
  }
}
