import { Pipe, PipeTransform } from '@angular/core';
import { DatePipe } from '@angular/common';
import { Globals } from './global';

@Pipe({
  name: 'dateFormat'
})
export class dateFormatPipe extends DatePipe implements PipeTransform {
  constructor(private global: Globals) {
    super('en-us');
  }

  transform(value: any, args?: any): any {
    return value && super.transform(value, this.global.DateFormat);
  }
}


@Pipe({
  name: 'dateTimeFormat'
})
export class dateTimeFormatPipe extends DatePipe implements PipeTransform {
  constructor(private global: Globals) {
    super('en-us');
  }

  transform(value: any, args?: any): any {
    return value && super.transform(value, this.global.DateTimeFormat);
  }
}


@Pipe({
  name: 'filterBytext'
})
export class FilterBytextPipe implements PipeTransform {

  transform(items: any[], prop: string, searchText: string): any {

    if (!items) return [];
    if (!searchText) return items;
    searchText = searchText.toLocaleLowerCase();
    return items.filter(item => item[prop].toLocaleLowerCase().indexOf(searchText) !== -1);
  }
}

@Pipe({
  name: 'uniquePipe'
})
export class UniquePipe implements PipeTransform {

  transform(value: any, prop: string): any {
    const array = value.map(x => x[prop])
      .filter((v, i, s) => s.indexOf(v) === i)
      .sort();

    return array;
  }
}