import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { InventoryComponent } from '../../pages/inventory/inventory.component';

// import { SNPE020Component } from '../../pages/inventory/SNPE020/SNPE020.component';
// import { SNPR026Component } from '../../pages/inventory/SNPR026/SNPR026.component';
// import { SNSE041Component } from '../../pages/inventory/SNSE041/SNSE041.component';
// import { SNSR063RComponent } from '../../pages/inventory/SNSR063R/SNSR063R.component';
// import { SNSE063Component } from '../../pages/inventory/SNSE063/SNSE063.component';
import { SNSE064Component } from '../../pages/inventory/SNSE064/SNSE064.component';
// import { SNPR026_MComponent } from '../../pages/inventory/SNPR026_M/SNPR026_M.component';
// import { SNPR026_PA4Component } from '../../pages/inventory/SNPR026_PA4/SNPR026_PA4.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';




@NgModule({
  declarations: [
    InventoryComponent,
    // SNPE020Component,
    // SNPR026Component,
    // SNSE041Component,
    // SNSR063RComponent,
    // SNSE063Component,
    SNSE064Component,
    // SNPR026_MComponent,
    // SNPR026_PA4Component,
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: InventoryComponent,
        children: [
          // {
          //   path: 'SNPE020',
          //   component: SNPE020Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPR026',
          //   component: SNPR026Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNSE041',
          //   component: SNSE041Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNSE063',
          //   component: SNSE063Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          {
            path: 'SNSE064',
            component: SNSE064Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNSR063R',
          //   component: SNSR063RComponent,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPR026_M',
          //   component: SNPR026_MComponent,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPR026_PA4',
          //   component: SNPR026_PA4Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },

        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class InventoryModule { }

