import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { PurChaseComponent } from 'src/app/pages/purchase/purchase.component';
import { MaterialImportModule } from '../shared/material.module';

@NgModule({
  declarations: [

    PurChaseComponent,
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: PurChaseComponent,
        children: [
          //{
          //  path: 'SNSE010',
          //  component: SNSE010Component,
          //}
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard],
})
export class PurChaseModule { }
