import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';

import { AuthGuard } from 'src/app/core/auth-guard.service';

import { ReceiptComponent } from 'src/app/pages/receipt/receipt.component';

// import { SNPE018Component } from '../../pages/receipt/SNPE018/SNPE018.component';
// import { SNPE024Component } from '../../pages/receipt/SNPE024/SNPE024.component';
// import { SNPP097Component } from '../../pages/receipt/SNPP097/SNPP097.component';
// import { SNPR025Component } from '../../pages/receipt/SNPR025/SNPR025.component';
// import { SNPR033Component } from '../../pages/receipt/SNPR033/SNPR033.component';
import { SNM080PComponent } from '../../pages/receipt/SNM080P/SNM080P.component';
import { SNPE007Component } from '../../pages/receipt/SNPE007/SNPE007.component';
import { SNPE010Component } from '../../pages/receipt/SNPE010/SNPE010.component';
 import { SNPE016Component } from '../../pages/receipt/SNPE016/SNPE016.component';
 import { SNPE017Component } from '../../pages/receipt/SNPE017/SNPE017.component';
// import { SNPE019Component } from '../../pages/receipt/SNPE019/SNPE019.component';
 import { SNPE031Component } from '../../pages/receipt/SNPE031/SNPE031.component';
// import { SNPE021Component } from '../../pages/receipt/SNPE021/SNPE021.component';
// import { SNPE040Component } from '../../pages/receipt/SNPE040/SNPE040.component';
// import { SNPP066Component } from '../../pages/receipt/SNPP066/SNPP066.component';
// import { SNPP067Component } from '../../pages/receipt/SNPP067/SNPP067.component';
import { SNPP202Component } from '../../pages/receipt/SNPP202/SNPP202.component';
import { SNPR019Component } from '../../pages/receipt/SNPR019/SNPR019.component';
// import { SNPE018_MComponent } from 'src/app/pages/receipt/SNPE018_M/SNPE018_M.component';
import { MaterialImportModule } from '../shared/material.module';
import { SNPR020Component } from 'src/app/pages/receipt/SNPR020/SNPR020.component';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { SaleOrderModule } from '../saleorder/saleorder.module';

@NgModule({
  declarations: [
    
    ReceiptComponent,
    // SNPE018Component,
    // SNPE024Component,
    // SNPP097Component,
    // SNPR025Component,
    // SNPR033Component,
    SNM080PComponent,
    SNPE007Component,
    SNPE010Component,
     SNPE016Component,
     SNPE017Component,
    // SNPE019Component,
     SNPE031Component,
    // SNPE021Component,
    // SNPE040Component,
    // SNPP066Component,
    // SNPP067Component,
    SNPP202Component,
    SNPR019Component,
    // SNPE018_MComponent,
    SNPR020Component
  ],
  imports: [
    SaleOrderModule,
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: ReceiptComponent,
        children: [
          // {
          //   path: 'SNPE018',
          //   component: SNPE018Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPE024',
          //   component: SNPE024Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPP097',
          //   component: SNPP097Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPR025',
          //   component: SNPR025Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPR033',
          //   component: SNPR033Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          {
            path: 'SNM080P',
            component: SNM080PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE007',
            component: SNPE007Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPE010',
            component: SNPE010Component,
            resolve: {
              role: RoleResolver
            },
          },
           {
             path: 'SNPE016',
             component: SNPE016Component,
             resolve: {
                 role: RoleResolver
             },
           },
           {
             path: 'SNPE017',
             component: SNPE017Component,
             resolve: {
                 role: RoleResolver
             },
           },
          // {
          //   path: 'SNPE019',
          //   component: SNPE019Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
           {
             path: 'SNPE031',
             component: SNPE031Component,
             resolve: {
                 role: RoleResolver
             },
           },
          // {
          //   path: 'SNPE021',
          //   component: SNPE021Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPE040',
          //   component: SNPE040Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPP066',
          //   component: SNPP066Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          // {
          //   path: 'SNPP067',
          //   component: SNPP067Component,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          {
            path: 'SNPP202',
            component: SNPP202Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNPR019',
            component: SNPR019Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //   path: 'SNPE018_M',
          //   component: SNPE018_MComponent,
          //   resolve: {
          //       role: RoleResolver
          //   },
          // },
          {
            path: 'SNPR020',
            component: SNPR020Component,
            resolve: {
              role: RoleResolver
            },
          },
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class ReceiptModule { }
