import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { Globals } from '../../../core/global';
import { ModalService } from '../../../core/modal.service';
import { AutoCompleteQueryComponent } from 'src/app/components/shared/auto-complete-query/auto-complete-query.component';
import * as moment from 'moment';

@Component({
  selector: 'SNPE037_M',
  templateUrl: './SNPE037_M.component.html',
  styleUrls: ['./SNPE037_M.component.css']
})

export class SNPE037_MComponent implements OnInit {

  constructor(
    private http: HttpService,
    private auth: AuthDecode,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private router: Router,
    private global: Globals,
    private route: ActivatedRoute,
  ) { }
  @ViewChild("dialogDoc", { static: false }) dialogDoc: any;
  @ViewChild("dialogDate", { static: false }) dialogDate: any;
  @ViewChild("dialogVat", { static: false }) dialogVat: any;
  @ViewChild("dialogInvo", { static: false }) dialogInvo: any;
  @ViewChild("dialogCom", { static: false }) dialogCom: any;
  @ViewChild("dialogPart", { static: false }) dialogPart: any;
  @ViewChild("autocompleteVat", { static: false }) autocompleteVat: AutoCompleteQueryComponent;

  public sDocData: any;
  public sDateData: any;
  public sData: any;
  public sVatData: any;
  public sInvoData: any;
  public sComData: any;
  public DisableSave: any = true;
  public ShowDetail = false;
  public PageNo = "SNPE037_M";;
  public tableWorkFile: any = [];
  public valid: boolean = false;
  public oldValue: any;
  public ConfirmStatus: any = "";
  public SaveKit: any = false;
  public businessplace: any;
  public editTableHideCols: Array<string> = [];

  public ParamsSearch = {
    DOCUMENT_NO: '',
    DOCUMENT_DATE: null,
    DOCUMENT_DATE_SEARCH: moment(),
    DEST_PORT: null,
    VAT_NAME: null,
    VAT_LOOKUP: null,
    INVOICE_NO: null,
    INVOICE_DATE: null,
    INVOICE_DATE_SEARCH: null,
    DOCUMENT_TYPE: null,
    P_FORM_NO: null,
    VENDOR_CODE: null,
    CONFIRM_STATUS: null
  }

  public ParamsHeadData: any = {};

  public data: any = {};

  public tblFooterDetail37: any = [
    {
      fieldName: "PART_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      show: true
    },
    {
      fieldName: "AMOUNT_CIF",
      value: null,
      show: true
    },
    {
      fieldName: "EXCISE",
      value: null,
      show: true
    },
    {
      fieldName: "INTERIOR",
      value: null,
      show: true
    },
    {
      fieldName: "EXP_CLEANRANCE_AMT_B",
      show: true
    },
    {
      fieldName: "EXP_OTHER_AMT_B",
      show: true
    },
    {
      fieldName: "INCOME_TAX",
      show: true
    },
    {
      fieldName: "AMOUNT",
      show: true
    },
    {
      fieldName: "TOTAL",
      show: true
    }]

  public ParamsDetailData = {
    DOCUMENT_TYPE: null,
    DOCUMENT_NO: null,
    ITEM_NO: null,
    CONFIRM_DATE: null,
    VENDOR_CODE: null,
    VENDOR_TYPE: null,
    RETAIL_PRICE_B: null,
    UNIT_PRICE_B: null,
    UNIT_PRICE_C: null,
    NET_AMT_B: null,
    ORDER_NO: null,
    ORDER_DATE: null,
    ORDER_ITEM_NO: null,
    SUB_ITEM_NO: null,
    ORDER_PART_NO: null,
    ACCEPT_PART_NO: null,
    REASON_CODE: null,
    ITEM_QTY: null,
    KIT_FLAG: null,
    SUB_DOC_NO: null,
    JOB_TYPE: null,
    SEQ: null
  }

  public BusnessPlaces: any = [
    '00000', '00001', '00002', '00003', '00004', '00005', '00006', '00007', '00008', '00009', '00010',
    '00011', '00012', '00013', '00014', '00015', '00016', '00017', '00018', '00019', '00020'
  ];


  public ParamsWorkfile = {
    TMP_DOC_NO: null,
    TMP_DOC_DATE: null,
    REASON_CODE: '501',
    REASON_NAME_EN: 'ประกอบเป็นชุดใหญ่'
  }

  public tblFooterWorkFile: any = [
    {
      fieldName: "PART_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "QUANTITY",
      value: null,
      show: true
    },
    {
      fieldName: "AMOUNT",
      value: null,
      show: true
    }]


  //private loaded: boolean = false;
  public tableData: any;
  public tableName: string;
  public PartListData: any;
  public SK_SYSTEM_LIST: any = [];
  public ConfigDoc: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "",
    PlaceholderText: "Select Document",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetDoc",
    NoOfShowRecords: 30,
    MinLengthSearch: 5,
    UpperCase: true
  }

  public ConfigVat: any = {
    ColName: "LOOKUP_VAT",
    ColValue: "",
    PlaceholderText: "Select Vat",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetVat",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false,
    SourceParams: {
      INV_DATE: this.data.REF_INV_DATE
    },
  }

  public ConfigInv: any = {
    ColName: "LOOKUP_INV",
    ColValue: "",
    PlaceholderText: "Select Rate",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigInvSearch: any = {
    ColName: "INVOICE_NO",
    ColValue: "",
    PlaceholderText: "Select Rate",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetInv",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigCom: any = {
    ColName: "SK_SYSTEM_ID",
    ColValue: "SK_SYSTEM_ID",
    PlaceholderText: "Select Company",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetCom",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: false
  }

  public ConfigDocDate: any = {
    ColName: "DOCUMENT_DATE",
    ColValue: "",
    PlaceholderText: "Select Document Date",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetDate",
    NoOfShowRecords: 50,
    MinLengthSearch: 2
  }

  public ConfigReason: any = {
    ColName: "LOOKUP_REASON",
    PlaceholderText: "Select Reason Code",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetReason",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public ConfigPart: any = {
    ColName: "LOOKUP",
    ColValue: "",
    PlaceholderText: "Select Part No.",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetDocPart",
    NoOfShowRecords: 30,
    MinLengthSearch: 3,
    UpperCase: true
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP_VENDOR_NAME",
    ColValue: "",
    PlaceholderText: "Select Vender Code",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetVendor",
    NoOfShowRecords: 50,
    MinLengthSearch: 0
  }

  public ConfigPartKIT: any = {
    ColName: "LOOKUP_PART",
    PlaceholderText: "Select Part No.",
    SourceController: "AC",
    SourceMethodName: "SNPECOMMON_GetPartKit",
    NoOfShowRecords: 30
  }

  ngOnInit() {

    this.ParamsSearch.DOCUMENT_TYPE = "RD";
    this.ParamsSearch.P_FORM_NO = "SNPE037_M";
    this.ConfigDoc.SourceParams = { DOCUMENT_TYPE: "RD" };

    this.businessplace = "";

    this.http.get("AC", "SNPE019_M_GetSKSYSTEM")
      .subscribe(res => {

        this.SK_SYSTEM_LIST = res.Table
      })
  }

  FormatDate(date) {

    let d = new Date(date);
    let Day = d.getDate().toString();
    let NewDay = Day.toString().length < 2 ? '0' + Day.toString() : Day.toString()
    let Month = d.getMonth() + 1;
    let NewMonth = Month.toString().length < 2 ? '0' + Month.toString() : Month.toString()
    let Year = d.getFullYear().toString();
    return Year + NewMonth + NewDay;
  }

  BackToGrid() {
    this.Search();
    this.ShowDetail = false;
  }

  Search() {
    this.ShowDetail = false;
    this.tableData = [];
    if (this.ParamsSearch.DOCUMENT_DATE_SEARCH) {
      this.ParamsSearch.DOCUMENT_DATE = this.FormatDate(this.ParamsSearch.DOCUMENT_DATE_SEARCH)
    } else {
      this.ParamsSearch.DOCUMENT_DATE = null;
    }
    if (this.ParamsSearch.INVOICE_DATE_SEARCH) {
      this.ParamsSearch.INVOICE_DATE = this.FormatDate(this.ParamsSearch.INVOICE_DATE_SEARCH)
    } else {
      this.ParamsSearch.INVOICE_DATE = null
    }
    this.ParamsSearch.CONFIRM_STATUS = null;
    if (this.ConfirmStatus === "Y") {
      this.ParamsSearch.CONFIRM_STATUS = "Y";
    }
    if (this.ConfirmStatus === "N") {
      this.ParamsSearch.CONFIRM_STATUS = "N";
    }
    this.http.post("AC", "SNPECOMMON_GetTransactionHeader", this.ParamsSearch)
      .subscribe(res => {
        this.tableData = res.Table;
         if (this.ParamsSearch.CONFIRM_STATUS == 'N') {
           this.tableData = this.tableData.filter(x => x.INDENT_STATUS == 'C')
         }
      })
  }

  ViewClick(event) {
    //console.log('eeeeeeee',event)
    if ((event.CONFIRM_DATE == null || event.CONFIRM_DATE == "") && event.INDENT_STATUS == 'N') {
      this.modal.warning("Cannot confirm. Because this document not to shevle", this.viewref)
    }
    this.data.DOCUMENT_TYPE = event.DOCUMENT_TYPE;
    this.data.DOCUMENT_NO = event.DOCUMENT_NO;
    this.data.DOCUMENT_DATE = this.getDateParam(event.DOCUMENT_DATE);
    //this.ParamsSearch.DOCUMENT_TYPE = event.DOCUMENT_TYPE;
    //this.ParamsSearch.DOCUMENT_NO = event.DOCUMENT_NO;
    this.FindHeadAuto();
    this.ShowDetail = true;
  }

  ValidatePart(autocomplete, event, data) {
    if (this.tableWorkFile.filter(x => x.PART_NO).length > 0) {

      let foundDup = this.tableWorkFile.some(x => x.PART_NO == event.PART_NO)
      let foundQuantity = this.tableWorkFile.some(x => x.PART_NO && !x.QUANTITY)
      if (foundDup) {
        this.modal.warning("P# " + event.PART_NO + " is duplicated!", this.viewref)
        this.valid = false;
      } else if (foundQuantity) {
        this.modal.warning("Please enter the quantity", this.viewref)
        this.valid = false;
      } else {
        let index = this.tableWorkFile.findIndex(x => x.SEQ == data.SEQ)
        this.tableWorkFile[index].PART_NO = event.PART_NO
        this.tableWorkFile[index].PART_NAME = event.PART_NAME_EN
        this.tableWorkFile[index].UNIT_PRICE = event.AVERAGE_COST
        this.valid = false;
        this.tableWorkFile = this.tableWorkFile.slice();
      }
    } else {
      let index = this.tableWorkFile.findIndex(x => x.SEQ == data.SEQ)
      this.tableWorkFile[index].PART_NO = event.PART_NO
      this.tableWorkFile[index].PART_NAME = event.PART_NAME_EN
      this.tableWorkFile[index].UNIT_PRICE = event.AVERAGE_COST
      this.valid = false;
      this.tableWorkFile = this.tableWorkFile.slice();
    }
  }


  Back() {
    this.dialogPart.Close()
  }

  DocDateChange(event) {

  }

  FindDoc() {

  }
  FindHead(evt) {
    this.data.DOCUMENT_NO = evt.DOCUMENT_NO;
    this.data.DOCUMENT_DATE = this.getDateParam(evt.DOCUMENT_DATE);
    this.FindHeadAuto();

    this.dialogDoc.Close();
  }
  BindData() {
    this.PartListData = [];

    if (this.data.STATUS_CODE === "55" && (this.data.CONFIRM_DATE === null || this.data.CONFIRM_DATE === "")) {
      this.DisableSave = false;
    } else {
      this.DisableSave = true;
    }
    this.data.TMP_INV_NO = this.data.REF_INV_NO;
    this.data.TMP_INV_DATE = this.data.REF_INV_DATE;
    // if (this.data.LAST_UPD_BY !== "" && this.data.LAST_UPD_BY !== null) {
    // }
    this.data.TMP_TOT_IMP = 0;
    this.data.TMP_TOT_LOC = 0;
    if (this.data.VENDOR_TYPE === "K" || this.data.VENDOR_TYPE === "J") {
      this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
    } else {
      this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
    }
    if (!this.data.ATTRIBUTE5) {
      this.data.ATTRIBUTE5 = this.SK_SYSTEM_LIST[0].SK_SYSTEM_ID;
      this.data.TNAME = this.SK_SYSTEM_LIST[0].TNAME;
    }
    this.ConfigVat.SourceParams.INV_DATE = this.data.REF_INV_DATE

    this.http.get("AC", "SNPE037_M_GetDocPart", this.data.DOCUMENT_TYPE, this.data.DOCUMENT_NO)
      .subscribe(result => {
        this.PartListData = result.Table;

        // console.log('ppppp',this.PartListData);

        if (!this.data.CONFIRM_DATE) {
          this.data.DEST_PORT = this.data.ATTRIBUTE3 || "00";
          this.autocompleteVat.textInput = this.data.DEST_PORT;
          this.autocompleteVat.query();
        } else {
          this.data.DEST_PORT = this.data.DEST_PORT;
          this.autocompleteVat.textInput = this.data.DEST_PORT;
          this.autocompleteVat.query();
        }

        setTimeout(() => {
          if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
            this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
            this.data.TMP_TOT_LOC = "0";
          } else {
            this.data.TMP_TOT_IMP = "0";
            this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
          }
        }, 500);

        let subdocmin = "", subdocmax = "";

        this.PartListData.forEach((v, i) => {
          if (v.SUB_DOC_NO > subdocmax) {
            subdocmax = v.SUB_DOC_NO;
          }
          if (v.SUB_DOC_NO < subdocmin || i === 0) {
            subdocmin = v.SUB_DOC_NO || '';
          }



          //
        })

        this.data.SUB_DOC_NO = subdocmin + " - " + subdocmax;

      });
  }
  FindHeadAuto() {
    this.http.get("AC", "SNPE037_M_GetDocDesc", this.data.DOCUMENT_TYPE, this.data.DOCUMENT_NO)
      .subscribe(result => {
        this.data = result.Table[0];    
        console.log('data',this.data)

        this.data.BUSINESS_PLACE = this.data.BUSINESS_PLACE || "00000";
        this.BindData();
      });
  }
  FindDate(evt) {
    this.data.DOCUMENT_DATE = evt.DOCUMENT_DATE;
    this.dialogDate.Close();
  }
  FindVat(evt) {
    this.data.DEST_PORT = evt.VAT_CODE;
    this.dialogVat.Close();
  }



  FindInvo(evt) {
    this.data.REF_INV_NO = evt.INVOICE_NO;
    this.dialogInvo.Close();
  }
  FindInvoAuto(evt, p) {
    if (p === "a") {
      this.data.REF_INV_NO = evt.INVOICE_NO;
      this.data.REF_INV_DATE = evt.INVOICE_DATE;
    }

    if (p === "s") {
      this.ParamsSearch.INVOICE_NO = evt.INVOICE_NO;
    }

  }
  FindCom(evt) {
    this.data.ATTRIBUTE5 = evt.SK_SYSTEM_ID;
    this.data.VENDOR_NAME_TH = evt.TNAME;
    this.dialogCom.Close();
  }
  OpenDocDialog() {
    this.http.post("AC", "SNPECOMMON_GetDoc", this.data)
      .subscribe(result => {
        this.sDocData = result.Table;
        this.dialogDoc.title = "Document No";
        this.dialogDoc.OpenDialog();
      });
  }

  keyupCal(val1, data) {
    if (data.QUANTITY !== undefined && val1 !== undefined) {
      if (val1 === "") {
        data.AMOUNT = 0;
      } else {
        data.AMOUNT = parseFloat(val1) * parseFloat(data.QUANTITY);
      }

    }
    this.PartListData = [...this.PartListData];

    this.CalVatTotal();

    setTimeout(() => {
      if (this.data.vendor_type === 'J' || this.data.vendor_type === 'K') {
        this.data.TMP_TOT_IMP = this.data.TOTAL_NET_B;
        this.data.TMP_TOT_LOC = "0";
      } else {
        this.data.TMP_TOT_IMP = "0";
        this.data.TMP_TOT_LOC = this.data.TOTAL_NET_B;
      }
    }, 100);

  }

  OpenDateDialog() {
    var p_date = null;
    if (this.data.DOCUMENT_DATE !== null) {
      p_date = this.data.DOCUMENT_DATE.toISOString().substring(0, 10);
    }
    this.http.get("AC", "SNPECOMMON_GetDate", p_date)
      .subscribe(result => {
        this.sVatData = result.Table;
        this.dialogDoc.title = "Document Date";
        this.dialogDate.OpenDialog();
      });
  }
  OpenVatDialog() {
    this.http.get("AC", "SNPECOMMON_GetVat")
      .subscribe(result => {
        this.sDateData = result.Table;
        this.dialogVat.title = "Vat";
        this.dialogVat.OpenDialog();
      });
  }
  OpenInvoDialog() {
    this.http.get("AC", "SNPECOMMON_GetInv", null, this.data.VENDER_CODE, null)
      .subscribe(result => {
        this.sInvoData = result.Table;
        this.dialogInvo.title = "Invoice";
        this.dialogInvo.OpenDialog();
      });
  }
  OpenComDialog() {
    this.http.get("AC", "SNPECOMMON_GetCom")
      .subscribe(result => {
        this.sComData = result.Table;
        this.dialogCom.title = "Company";
        this.dialogCom.OpenDialog();
      });
  }
  //DeliveryChange(evt) {
  //  this.businessplace = evt.value;
  //  this.data.BUSINESS_PLACE = evt.value;

  //}

  Save() {
    if (!this.data.DEST_PORT) {
      this.modal.warning("Please select Vat Code", this.viewref);
    } else if (!this.data.BUSINESS_PLACE) {
      this.modal.warning("Please select Business Place", this.viewref);
    } else {
      this.modal.confirm('Do you want to save change you have made?', this.viewref, this.ConfirmSave)
    }
  }

  ConfirmSave = () => {
    this.data.CREATE_DATE = new Date();
    this.data.LAST_UPD_PGM = 'SNPE037_M';
    this.data.LAST_UPD_DATE = new Date();
    this.data.LAST_UPD_NAME = this.global.GetTokenDetail("ssNameEN");
    this.data.REF_DOC_NO = this.getDateParam(this.data.REF_DOC_NO);
    this.data.LAST_IP_ADDR = this.global.GetTokenDetail("ssIPAddress");
    this.http.post('AC', 'SNPE037_M_Save', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.ngOnInit();
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.FindHeadAuto();
        }
        else if(res.Table[0].STATUS == 'CONFIRMED'){
          this.modal.warning('Someone is working on this document, please try again later',this.viewref)
        }
        else{
          this.modal.error('Found an error, please contract support team', this.viewref);
        }
      },err => {
        this.modal.error('Found an error, please contract support team', this.viewref);
      });
  }
  getDateParam(dt) {
    if (dt !== undefined) {
      dt = new Date(dt)
      let year = dt.getFullYear();
      let month = (1 + dt.getMonth()).toString().padStart(2, '0');
      let day = dt.getDate().toString().padStart(2, '0');
      var p_Date = year + '-' + month + '-' + day;
      return p_Date;
    }
  }
  AppendRow() {
    for (var i = 0; i < this.tableWorkFile.length; i++) {
      if (this.tableWorkFile[i].EDIT === "ADD") {
        this.tableWorkFile[i].EDIT = 'DEL';
        this.tableWorkFile[i].ITEM_NO = this.tableWorkFile.length;
      }
    }
    this.tableWorkFile = [...this.tableWorkFile, { 'EDIT': 'ADD', 'ITEM_NO': '' }];
  }
  DeleteRow(Item) {
    for (var i = 0; i < this.tableWorkFile.length; i++) {
      if (this.tableWorkFile[i].ITEM_NO === Item) {
        this.tableWorkFile.splice(i, 1);
      }
    }
    this.tableWorkFile = [...this.tableWorkFile];
  }

  GetPartKit(evt, data, index) {
    var found = this.tableWorkFile.find((element, i) => index != i && element.PART_NO == evt.PART_NO);
    if (found !== undefined) {
      this.modal.warning("P# " + evt.PART_NO + " is duplicated!", this.viewref)
      return;
    }
    // this.tableWorkFile[index] = evt;
    this.tableWorkFile[index].PART_NO = evt.PART_NO;
    this.tableWorkFile[index].PART_NAME = evt.PART_NAME;
    this.tableWorkFile[index].QUANTITY = evt.QUANTITY;
    this.tableWorkFile[index].OH_QTY = evt.OH_QTY;
    this.tableWorkFile[index].UNIT_PRICE = evt.UNIT_PRICE;
    this.tableWorkFile[index].AMOUNT = evt.AMOUNT;

    this.tableWorkFile = [...this.tableWorkFile];
    // for (var i = 0; i < this.tableWorkFile.length; i++) {
    //   if (this.tableWorkFile[i].ITEM_NO === data.ITEM_NO) {
    //     this.tableWorkFile[i].PART_NO = evt.PART_NO;
    //     this.tableWorkFile[i].PART_NAME = evt.PART_NAME;
    //     this.tableWorkFile[i].QUANTITY = evt.QUANTITY;
    //     this.tableWorkFile[i].OH_QTY = evt.OH_QTY;
    //     this.tableWorkFile[i].UNIT_PRICE = evt.UNIT_PRICE;
    //     this.tableWorkFile[i].AMOUNT = evt.AMOUNT;
    //   }
    // }
  }

  AddRow() {
    this.tableWorkFile.push({
      PART_NAME: null,
      PART_NO: null,
      QUANTITY: null,
      REASON_CODE: null,
      ITEM_NO: this.tableWorkFile.length + 1,
      TMP_DOC_DATE: null,
      TMP_DOC_NO: null,
      UNIT_PRICE: null,
      AMOUNT: 0
    })
    this.tableWorkFile = this.tableWorkFile.slice();
  }

  QuantityChange(oldValue, event, data) {
    // console.log('eeee',oldValue,event,data)
    let param = {
      PART_NO: data.PART_NO,
      QUANTITY: data.QUANTITY
    }
    this.http.post("AC", "SNPE018_M_CheckQty", param)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Fail') {
          this.modal.error(res.Table[0].MSG, this.viewref);
          this.valid = false;
        } else {
          this.valid = true;
        }
        this.tblFooterWorkFile[2].value = this.tableWorkFile.map(x => x.AMOUNT).reduce((prev, next) => prev + next);
        this.tableWorkFile = this.tableWorkFile.slice();
      })

  }

  keyupCalQ(evt, data) {
    if (data.QUANTITY > data.OH_QTY) {
      data.QUANTITY = data.OH_QTY;
      this.tableWorkFile = [...this.tableWorkFile];
      this.modal.warning('Item Qty cannot more than balance', this.viewref,
        () => {
          evt.target.focus();
        })
    }
    data.AMOUNT = (parseFloat(data.QUANTITY) * parseFloat(data.UNIT_PRICE)) || 0;
    this.tableWorkFile = [...this.tableWorkFile];
  }

  Cancel() {
    this.modal.confirm('Are you sure to cancel this document??', this.viewref, this.ConfirmCancel)
  }
  ConfirmCancel = () => {
    this.data.LAST_IP_ADDR = this.global.GetTokenDetail("ssIPAddress");
    this.http.post('AC', 'SNPECOMMON_Cancle', this.data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.ngOnInit();
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.FindHeadAuto();
        }
      });
  }


  SelectedVatCode(event) {
    this.data.DEST_PORT = event.VAT_CODE;
    this.data.VAT_DESC = event.VAT_DESC;
    this.data.VAT_FLAG = event.VAT_FLAG;
    this.data.VAT_RATE = event.VAT_RATE;
    this.data.TAX_FLAG = event.TAX_FLAG;
    this.data.TAX_RATE = event.TAX_RATE;
  }

  CalVatTotal() {

    //this.data.TOTAL_NET_B = 0;
    this.data.TOTAL_VAT = 0;
    this.data.WHT_AMOUNT = 0;
    
    this.data.TOTAL_VAT = this.data.TOTAL_NET_B * (this.data.VAT_RATE / 100)
    this.data.WHT_AMOUNT = this.data.TOTAL_NET_B * (this.data.TAX_RATE / 100)

    // this.PartListData.forEach(x => {
    //   this.data.TOTAL_NET_B += x.AMOUNT
    //   this.data.TOTAL_VAT += x.AMOUNT * (this.data.VAT_RATE / 100);
    //   this.data.WHT_AMOUNT += x.AMOUNT * this.data.TAX_RATE
    // });

    //console.log('this.data.WHT_AMOUNT',this.data.WHT_AMOUNT)
  }


  TotalQty() {
    return this.PartListData.reduce((a, b) => a + (b.QUANTITY || 0), 0);
  }

  TotalAmountCIF() {
    return this.PartListData.reduce((a, b) => a + (b.AMOUNT_CIF || 0), 0);
  }

  TotalExpense() {
    return this.PartListData.reduce((a, b) => a + (b.MATERIAL_COST || 0), 0);
  }

  TotalAmount() {
    return this.PartListData.reduce((a, b) => a + ((b.ITEM_QTY || 0) * (b.UNIT_PRICE_B || 0)
      + (b.EXP_CLEANRANCE_AMT_B || 0)
      + (b.EXP_OTHER_AMT_B || 0)
      + (b.INCOME_TAX || 0)
      + (b.EXCISE || 0)
      + (b.INTERIOR || 0)
    )
      , 0);
  }
}
