import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snsd201',
  templateUrl: './SNSD201.component.html',
  styleUrls: ['./SNSD201.component.css']
})

export class SNSD201Component implements OnInit {


  constructor(
    private http: HttpService,
    private modal: ModalService,
    private router: Router,
    private viewref: ViewContainerRef
  ) { }

  public currentDate: string;

  public Data: any = {
    PROCESS_YEAR: null,
    PROCESS_MONTH: null,
    FILE_NAME_PART: null,
    FILE_NAME_TYPE: null,
    STATUS: null
  };
  ngOnInit() {
    this.currentDate = this.GetFormateDate()
  }

  GetFormateDate() {

    let _date = new Date();
    let day = _date.getDate();
    let year = _date.getFullYear()
    let month = _date.getMonth() + 1;
    let newMonth = month.toString().length < 2 ? 0 + '' + month : month
    return day + '-' + newMonth + '-' + year

  }
  CalculateAndExport() {
    this.http.post("AC", "SNSD201_Calculate", this.Data)
      .subscribe(result => {
        if (result.Status === "DONE") {
          this.Data.STATUS = true;
          this.Data.FILE_NAME_PART = result.filenamePart;
          this.Data.FILE_NAME_TYPE = result.filenameType;
        } else {
          this.Data.STATUS = false;
        }
      })
  }
  DownloadPart() {
    this.http.Download('AC', 'SNSD201_Download_Part', this.Data)
      .subscribe(res => {
        if (res) {
          this.WriteContents(res, this.Data.FILE_NAME_PART)
        } else {
          this.modal.error('EXPORT_NOT_COMPLETE', this.viewref)
        }

      })
  }
  WriteContents(content, name) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = name;
    a.click();
  }
  DownloadType() {
    this.http.Download('AC', 'SNSD201_Download_Type', this.Data)
      .subscribe(res => {
        if (res) {
          this.WriteContents(res, this.Data.FILE_NAME_TYPE)
        } else {
          this.modal.error('EXPORT_NOT_COMPLETE', this.viewref)
        }

      })
  }
}

