import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';

@Component({
    selector: 'snsj006_m',
    templateUrl: './SNSJ006_M.component.html',
    styleUrls: ['./SNSJ006_M.component.css']
})



export class SNSJ006_MComponent implements OnInit {


    constructor(
        private http: HttpService,
        private modal : ModalService,
        private viewref : ViewContainerRef,
        private global : Globals
    ) { }

    public CustomerList: any;
    private loaded: boolean = false;
    private fileList : any = [];
    public ProcessDone : boolean = false;
    public ReportData : any = [];
    ngOnInit() {
   
    }

    StartProcess(){
        this.ReportData = [];
        this.fileList = [];
        this.http.get("AC","SNSJ006_M_INITAIL")
            .subscribe(res => {
           
                //console.log(res)

                if(res.Table.length > 0){
                    this.ProcessDone = true;
                    this.ReportData = res.Table
                    this.modal.info("Process Complete !.......",this.viewref)
                    
                }else{
                    if(res.Table1[0].STATUS == 'Done'){
                        this.modal.info("Process Complete !.......",this.viewref)
                        this.ProcessDone = true;
                    }else{
                        this.modal.warning("Process Not Complete !.......",this.viewref)
                        this.ProcessDone = false;
                    }
                   
                }
        },(err) => {
            this.modal.warning(err.message,this.viewref)
            this.ProcessDone = false;
        })
    }


    GenerateReport(){
        let index = 0;      
        for(var item of this.ReportData){

            let location = item["LOCATION_NO"]
            if(!item["LOCATION_NO"]){
                location = "ALL"
            }

            let reportParams = {
                P_COMPANY_CODE : this.global.GetTokenDetail("ssComCode"),
                P_SEQ_NO_FROM : item["SEQ_FROM"],
                P_SEQ_NO_TO : item["SEQ_TO"],
                P_LOCATION_NO : location,
                P_FORM_ID: 'SNSJ006_M'
            }

            let fileName1 = "SNSR022" + "_" + location + '_' + this.FormatDate() + "." + "PDF";
            let fileName2 = "SNSR023" + "_" + location + '_' + this.FormatDate() + "." + "PDF"

            this.http.getParams("AC", ["SNSJ006_M_GenerateReport","PMS_RPT_ACC_SNSR022_M","PMS_RPT_ACC_SNSR023_M",fileName1,fileName2], reportParams)
                .subscribe(result => {
                    this.fileList.push({
                        file_path : result.substring(1),
                        file_name : fileName1
                    })

                    this.fileList.push({
                        file_path : result.substring(1),
                        file_name : fileName2
                    })
                        index++
                    if(index == this.ReportData.length){
                        //console.log(this.fileList)
                        this.DownLoad();
                    }
            })

        }         
    }

    DownLoad(){
        this.http.DownloadMultipleFilesAsZip("AC","SNSJ006_M_DowLoad",this.fileList)
        .subscribe(res =>{
            //this.modal.info("Process Complete !.......",this.viewref)
            this.WriteFile(res);
        })
    }


    WriteFile(res){
        var blob = new Blob([res], { type: "application/octet-stream" });                
        var fileURL = URL.createObjectURL(blob);
        var a = document.createElement('a');
        a.href = fileURL;
        a.target = '_blank';
        a.download = "SNSJ006_M.zip";
        document.body.appendChild(a);
        a.click();
        document.body.removeChild(a);
    }


    FormatDate() {

        let d = new Date();
        let Day = d.getDate().toString();
        let Month = d.getMonth() + 1;
        let NewMonth = Month.toString().length < 2 ? '0' + Month.toString() : Month.toString()
        let Year = d.getFullYear().toString();
        let hours = d.getHours();
        let minute = d.getMinutes();
        let second = d.getSeconds();
    
        return  Day + '-' + NewMonth + '-' + Year + '_' + hours + '-' + minute + '-' + second;
      }



}
