import { Component, ElementRef, OnInit, ViewContainerRef } from '@angular/core';
import { Globals } from 'src/app/core/global';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'runbat1',
    templateUrl: 'runbat1.component.html',
    styleUrls: ['runbat1.component.css']
})

export class RunBat1Component implements OnInit {
    constructor(
        private http: HttpService,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private el: ElementRef,
        private global: Globals
    ) { }

    public TotalOrder: number;
    public TotalPart: number;
    public TotalAllocate: number;

    ngOnInit() { }

    BeginProcess() {
        this.modal.confirm("Confirm Run Allocate Afternoon ??", this.viewref
            , () => {
                this.http.post("SL", "RUNBAT1_Process", null)
                    .subscribe(result => {
                        if(result == "Fail") {
                            this.modal.error("Something eror, please contact administrator.", this.viewref);
                        } else {
                            this.TotalOrder = result.TotalOrder;
                            this.TotalPart = result.TotalPart;
                            this.TotalAllocate = result.TotalAllocate;
                            this.modal.info("Process complete....", this.viewref);
                        }
                    }, err => {
                        this.modal.error("Something eror, please contact administrator.", this.viewref);
                    })
            }, () => { })
    }
}