import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { FormControl } from '@angular/forms';
import * as moment from 'moment';

import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snba007a',
  templateUrl: './SNBA007_A.component.html',
  styleUrls: ['./SNBA007_A.component.css']
})

export class SNBA007AComponent implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) {

  }

  private CurDate = new FormControl(new Date());
  private StartDate = new FormControl(new Date());
  private EndDate = new FormControl(new Date());
  private cDate = new FormControl(new Date());
  private inputCurDate = new FormControl(new Date());

  private formData: any = {};
  public formList: Array<any>


  ngOnInit() {
    this.GetJobBatchID();
  }

  GetJobBatchID() {
    this.http.get("IC", "GetJobBatchID2", "SNSJ003")
      .subscribe(result => {
        this.formList = result.Table;
        this.ChangeCurrentTab({ index: 0 });
      })
  }


  SaveData() {
    this.modal.confirm("Are you sure to save " + this.formData.JOB_NAME + "?", this.viewRef,
      () => {
        this.http.post("IC", "SaveJobBatchIDWithPC", JSON.stringify(this.formData))
          .subscribe(result => {
            if (result === "Done") {
              this.modal.info("Saved data successfully", this.viewRef);
              this.GetJobBatchID();
            }
          }, (err) => {
            console.log(err, 'err')
          })

      }, () => { })
  }

  // BackToMain() {
  //   this.router.navigate(['/main']);
  // }

  ChangeCurrentTab(tab) {
    this.formData = this.formList[tab.index];
  }

  LockOrderWeb(form) {
    this.modal.confirm("Are you sure to Lock Order Web for " + form.JOB_NAME + "?", this.viewRef
      , () => {
        this.http.get("SL", "SNBA007_A_LockOrder", form.JOB_ID, form.BATCH_ID)
          .subscribe(result => {
            this.modal.info("Lock Order Web for " + form.JOB_NAME + " Successfully.", this.viewRef);
            this.GetJobBatchID();
          }, (err) => {
            this.modal.error("Unable to Lock Order Web, Please contact MA to solve this issue.", this.viewRef);
          })
      }, () => { })
  }

  UnLockOrderWeb(form) {
    this.modal.confirm("Are you sure to Unlock Order Web for " + form.JOB_NAME + "?", this.viewRef
      , () => {
        this.http.get("SL", "SNBA007_A_UnLockOrder", form.JOB_ID, form.BATCH_ID)
          .subscribe(result => {
            this.modal.info("Unlock Order Web for " + form.JOB_NAME + " Successfully.", this.viewRef);
            this.GetJobBatchID();
          }, (err) => {
            this.modal.error("Unable to Unlock Order Web, Please contact MA to solve this issue.", this.viewRef);
          })
      }, () => { })
  }

}

