import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'snjf003',
  templateUrl: './SNJF003.component.html',
  styleUrls: ['./SNJF003.component.css'],
})



export class SNJF003Component implements OnInit {

  constructor(
    private Http: HttpService,
    private router: Router,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public tableData: any = [];
  public tableDataDetail: any = [];

  public dataDetail: any = {};
  public params: any = {};

  public selection = new SelectionModel<any>(true, []);
  public showPage: any;
  public DataIsSelected: any = [];

  ngOnInit() {
    this.params.ATTACH_SHEET = 'Y'
    this.getFileName()
    this.params.TOTAL_REC = 0;
    this.showPage = 0;
  }

  public tblFooter: any = [
    //{
    //  fieldName: "PACK_TIME",
    //  value: "Total",
    //  show: true
    //},
    {
      fieldName: "GROSS_WEIGHT",
      value: null,
      show: true
    },
    {
      fieldName: "QTY",
      value: null,
      show: true
    },
    {
      fieldName: "AMOUNT",
      value: null,
      show: true
    }]

  public tblFooterDetail: any = [
    {
      fieldName: "SUB_ITEM_NO",
      value: "Total",
      show: true
    },
    {
      fieldName: "PACK_QTY",
      value: null,
      show: true
    }]

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNJF003_GetCustomerCode",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  //public lookupBranchCodeConfig: any = {
  //  ColName: "LOOKUP_BRANCH_CODE",
  //  PlaceholderText: "Select Branch Code",
  //  SourceController: "SL",
  //  SourceMethodName: "SNJF003_getBranchCode",
  //  NoOfShowRecords: 50,
  //  MinLengthSearch: 0,
  //  SourceParams: {
  //    DATA: this.params
  //  },
  //  UpperCase: true
  //}

  public lookupInvoiceNoConfig: any = {
    ColName: "LOOKUP_INVOICE_NO",
    PlaceholderText: "Select Invoice No",
    SourceController: "SL",
    SourceMethodName: "SNJF003_getInvoiceNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;

    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;

    this.params.COUNTRY_CODE = values.COUNTRY;
    this.params.CURRENCY_CODE = values.CURRENCY_CODE;
    this.params.PAYMENT_TERM = values.PAYMENT_TERM;
    this.params.PRICE_TERM_CODE = values.PRICE_TERM_CODE;
    this.params.EXCHANGE_RATE = values.EXCHANGE_RATE;

  }

  //public SetSelectedBranchCode(values: any) {
  //  this.params.BRANCH_CODE = values.BRANCH_CODE;
  //  this.params.BRANCH_NAME = values.BRANCH_NAME;
  //}

  public SetSelectedInvoiceNo(values: any) {
    this.params.INVOICE_NO = values.INVOICE_NO;
    this.params.INVOICE_DATE = values.INVOICE_DATE;
    this.params.DOCUMENT_TYPE = values.DOCUMENT_TYPE;
    //this.params.COUNTRY_CODE = values.COUNTRY_CODE
    // this.params.PRICE_TERM_CODE = values.PRICE_TERM_CODE
    //  this.params.CURRENCY_CODE = values.CURRENCY_CODE
    // this.params.EXCHANGE_RATE = values.EXCHANGE_RATE
    this.params.SENT_BY = values.SENT_BY
    // this.params.PAYMENT_TERM = values.PAYMENT_TERM
    this.params.BL_AWB_DATE = values.BL_AWB_DATE
    this.params.BL_AWB_NO = values.BL_AWB_NO
    this.params.VESSEL_FLIGHT_N = values.VESSEL_FLIGHT_N
    this.params.FWD_CHARGE_C = values.FWD_CHARGE_B
    this.params.FREIGH_CHARGE_C = values.FREIGH_CHARGE_C
    this.params.INSURANCE_C = values.INSURANCE_C
    this.getPreInvoice()
    this.Search()
  }

  rowClick(row: any) {
    this.dataDetail = {}
    this.dataDetail = row
    this.Http.post('SL', 'SNJF003_getDataDetail', this.dataDetail)
      .subscribe(res => {
        this.tableDataDetail = res.Table;
      })
    this.showPage = 1;
  }

  clickBack() {
    this.showPage = 0;
  }

  UpdateInvoice() {
    var chk = 0;

    if (this.DataIsSelected.length == 0) {
      this.modal.warning("Please select data..", this.viewref);
    }
    else if (!this.params.VESSEL_FLIGHT_N) {
      this.modal.warning("Flight No. is not input..", this.viewref);
    }
    else if (!this.params.BL_AWB_NO) {
      this.modal.warning("AWB No. is not input..", this.viewref);
    }
    else if (!this.params.BL_AWB_DATE) {
      this.modal.warning("AWB Date. is not input..", this.viewref);
    }
    else if (this.params.EXCHANGE_RATE == 0) {
      this.modal.warning("Exchange Rate Invalid.", this.viewref);
    }
    else {
      this.DataIsSelected.forEach((e) => {
        if (!e.CONTAINER_NO) {
          chk = + 1;
        }
      });
    }

    if (chk == 0) {
      this.Http.post('SL', 'SNJF003_UpdateInvoiceDetail', this.DataIsSelected)
        .subscribe(res => {
          if (res.Table[0].STATUS == 'DONE') {
            this.modal.info("Update Invoice Successful.", this.viewref);
            this.Search();
            this.selection.clear();
            this.DataIsSelected = []

            if (this.params.ATTACH_SHEET == 'Y') {
              this.OpenReport();
            }


          }
        });
    } else {
      this.modal.warning("Container No. Invalid.", this.viewref);
    }
  }

  GenTextfile() {
    this.modal.info("GEN TEXT!!", this.viewref);
  }

  ConfirmUTDHeader() {
    this.modal.confirm('Do you want to update on this data?', this.viewref, this.UpdateHeader)
  }

  UpdateHeader = () => {
    if (!this.params.INVOICE_NO) {
      this.modal.warning("Invoice is not input..", this.viewref);
    }
    else if (!this.params.VESSEL_FLIGHT_N) {
      this.modal.warning("Flight No. is not input..", this.viewref);
    }
    else if (!this.params.BL_AWB_NO) {
      this.modal.warning("AWB No. is not input..", this.viewref);
    }
    else if (!this.params.BL_AWB_DATE) {
      this.modal.warning("AWB Date. is not input..", this.viewref);
    }
    else {
      this.Http.post('SL', 'SNJF003_UpdateInvoiceHeader', this.params)
        .subscribe(res => {
          if (res.Table[0].STATUS == 'DONE') {
            this.modal.info("Update Invoice Header Successful.", this.viewref);
            this.Search()
          }
        });
    }
  }

  getPreInvoice() {
    this.Http.post('SL', 'SNJF003_getPreInvoice', this.params)
      .subscribe(res => {
        this.params.PINVOICE_NO = res.Table[0].PINVOICE_NO;
        this.params.PINVOICE_DATE = res.Table[0].PINVOICE_DATE;
      })
  }

  Search() {
    this.tableData = [];
    this.Http.post('SL', 'SNJF003_getData', this.params)
      .subscribe(res => {
        this.tableData = res.Table;
        if (this.tableData.length > 0) {
          this.params.TOTAL_REC = this.tableData.length
        }
      })
  }


  CheckboxChange(event, data) {
    if (event.checked) {
      this.DataIsSelected.push(data);
    }
    else {
      this.DataIsSelected.splice(this.DataIsSelected.indexOf(data), 1);
    }
  }

  getFileName() {
    this.Http.get('SL', 'SNJF003_getFileName')
      .subscribe(res => {
        this.params.TO_PATH = res.Table[0].TO_FILE_NAME;
      });
  }

  isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.tableData.length;
    return numSelected === numRows;
  }

  Toggle() {
    if (this.isAllSelected()) {
      this.selection.clear()
      this.tableData.map(x => {
        this.DataIsSelected = [];
      })
    } else {
      this.tableData.forEach(row => this.selection.select(row));
      this.DataIsSelected = [];
      this.tableData.map(x => {
        this.DataIsSelected.push(x);
      })
    }
  }

  private OpenReport() {
    this.global.GoToReport("PMS_RPT_SALES_SNSE033R_N", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_DOC_TYPE: this.params.DOCUMENT_TYPE,
      P_DOC_NO: this.params.INVOICE_NO
    })
  }


  public CheckPrintChange(value) {
    if (value.checked == true) {
      this.params.ATTACH_SHEET = 'Y'
    }
    else {
      this.params.ATTACH_SHEET = 'N'
    }
  }
}
