import { Component, OnInit, ViewChild, ViewContainerRef, EventEmitter } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';

@Component({
  selector: 'snsq022',
  templateUrl: './SNSQ022.component.html',
  styleUrls: ['./SNSQ022.component.css']
})

export class SNSQ022Component implements OnInit {

  public params: any = {};
  public isCanUpdate: boolean = false;
  public IsSelectTab: number = 0;

  public dataOnClick: any = {}

  constructor(
    private Http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public fromData: any = {};
  public tableData1: any = [];
  public tableData2: any = [];
  public tableData3: any = [];
  public tableData4: any = [];
  public tableData5: any = [];
  public tableData6: any = [];

  public tblFooterData1: any = [
    {
      fieldName: "CUSTOMER_NAME",
      value: "Total",
      show: true
    },
    {
      fieldName: "CNT_ORDER_NO",
      value: null,
      show: true
    },
    {
      fieldName: "SUM_ORDER_QTY",
      value: null,
      show: true
    },
    {
      fieldName: "SUM_ACCEPT_QTY",
      value: null,
      show: true
    },
    {
      fieldName: "SUM_NET_WEIGHT",
      value: null,
      show: true
    },
    {
      fieldName: "SUM_NET_DIMENSION",
      value: null,
      show: true
    },
    {
      fieldName: "SUM_AMOUNT",
      value: null,
      show: true
    }
  ]

  public totalRecord1 = 0;
  public totalRecord2 = 0;
  public totalRecord3 = 0;
  public totalRecord4 = 0;
  public totalRecord5 = 0;
  public clickedRow: any;

  public tabIndex: number = 0;


  @ViewChild("SNSQ01E_UPLOAD", { static: false }) SNSQ01E_UPLOAD: any;

  ngOnInit() {

    this.params.FROM_DATE = new Date("January 1, 2000 07:00:00");
    this.params.TO_DATE = new Date();
  }

  InitData() {
    this.params.ORDER_NO = null;
    this.params.ORDER_PART_NO = null;
    this.params.ORDER_CLASS = null;
  }

  tabClick(tab: any) {
    if (tab != 0) {
      this.IsSelectTab = tab
      this.tabIndex = tab
      this.fromData = null;
      this.isCanUpdate = false;
      this.SearchByCustomerCode()
    }
  }

  InitTable() {
    this.tableData1 = [];
    this.tableData2 = [];
    this.tableData3 = [];
    this.tableData4 = [];
    this.tableData5 = [];
    this.tableData6 = [];
  }

  Search = () => {
    this.dataOnClick = {};
    this.tabIndex = 0;
    this.InitTable();
    this.Http.post('SL', 'SNSQ022_GetSummary', this.params)
      .subscribe(res => {
        this.tableData1 = res.Table;
      })
  }

  SearchByCustomerCode = () => {
    if (this.IsSelectTab == 1) {
      this.Http.post('SL', 'SNSQ022_GetInComplete', this.dataOnClick)
        .subscribe(res => {
          this.tableData2 = res.Table;
          if (this.tableData2.length > 0) {
            this.tableData2.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }


        })
    }
    else if (this.IsSelectTab == 2) {
      this.Http.post('SL', 'SNSQ022_GetComplete', this.dataOnClick)
        .subscribe(res => {
          this.tableData3 = res.Table;
          if (this.tableData3.length > 0) {
            this.tableData3.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        })
    }
    else if (this.IsSelectTab == 3) {
      this.Http.post('SL', 'SNSQ022_GetUnitPrice', this.dataOnClick)
        .subscribe(res => {
          this.tableData6 = res.Table;
          if (this.tableData6.length > 0) {
            this.tableData6 = this.tableData6.filter(value => value.UNIT_PRICE_MASTER == null);
            this.tableData6.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        })
    }
    else if (this.IsSelectTab == 4) {
      this.Http.post('SL', 'SNSQ022_GetUnitPriceFail', this.dataOnClick)
        .subscribe(res => {
          this.tableData4 = res.Table;
          if (this.tableData4.length > 0) {
            this.tableData4 = this.tableData4.filter(value => value.UNIT_PRICE_MASTER != null);
            this.tableData4.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        })
    }
    else if (this.IsSelectTab == 5) {
      this.Http.post('SL', 'SNSQ022_GetInCompleteTariff', this.dataOnClick)
        .subscribe(res => {
          this.tableData5 = res.Table;
          if (this.tableData5.length > 0) {
            this.tableData5.forEach((e, index) => {
              e.V_SEQ = index + 1;
            });
          }
        })
    }
  }




  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetCustomer",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public lookupOrderNoConfig: any = {
    ColName: "LOOKUP_ORDER_NO",
    ColValue: "",
    PlaceholderText: "Select Order No",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetOrderNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public lookupOrderPartNoConfig: any = {
    ColName: "LOOKUP_ORDER_PART_NO",
    ColValue: "",
    PlaceholderText: "Select Order Part No",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetOrderPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public lookupOrderClassConfig: any = {
    ColName: "ORDER_CLASS_DESC",
    ColValue: "",
    PlaceholderText: "Select Order Class",
    SourceController: "SL",
    SourceMethodName: "SNSQ022_GetOrderClass",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    SourceParams: {
      DATA: this.params
    },
    UpperCase: true
  }

  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUST_NAME_EN;
    this.InitData();
  }

  public SetSelectedOrderNo(value: any) {
    this.params.ORDER_NO = value.ORDER_NO;
  }

  public SetSelectedOrderPartNo(value: any) {
    this.params.ORDER_PART_NO = value.ORDER_PART_NO;
  }

  public SetSelectedOrderClass(value: any) {
    this.params.ORDER_CLASS = value.ORDER_CLASS;
  }

  ExportExcel(tab: any) {
    var ctrName = "";
    var type = "";
    var data = [];
    if (tab == 'TAB1') {
      ctrName = "SNSQ022_ExportSummary";
      type = "SUMMARY";
      data = this.tableData1;
    }
    else if (tab == 'TAB2') {
      ctrName = "SNSQ022_ExportIncomplete";
      type = "INCOMPLETE";
      data = this.tableData2;
    }
    else if (tab == 'TAB3') {
      ctrName = "SNSQ022_ExportComplete";
      type = "COMPLETE";
      data = this.tableData3;
    }
    else if (tab == 'TAB4') {
      ctrName = "SNSQ022_ExportUnitPriceFail";
      type = "UNIT_PRICE_FAIL";
      data = this.tableData4;
    }
    else if (tab == 'TAB5_1') {
      ctrName = "SNSQ022_ExportIncompleteTariff";
      type = "INCOMPLETE_TARIFF";
      data = this.tableData5;
    }
    else if (tab == 'TAB5_2') {
      ctrName = "SNSQ022_ExportImproperMaster";
      type = "IMPROPER_MASTER";
      data = this.tableData5;
    }
    else if (tab == 'TAB6') {
      ctrName = "SNSQ022_ExportUnitPriceFail";
      type = "UNIT_PRICE";
      data = this.tableData6;
    }
    if (ctrName && type) {
      this.Http.Download('SL', ctrName, JSON.stringify(data))
        .subscribe(res => {
          if (res) {
            this.WriteContents(res, type)
          } else {
            this.modal.error('Download not complete', this.viewref)
          }
        })
    }
  }

  WriteContents(content, type) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ022" + type + ".csv";
    a.click();
  }

  ConfirmUTD(type: any) {
    if (type == 'update') {
      if (this.fromData) {
        this.modal.confirm('Do you want to update on this data?', this.viewref, this.UpdateUnitPriceFail)
      }
      else {
        this.modal.info('Please select data for update!', this.viewref, this.UpdateUnitPriceFail)
      }
    }
    else if (type == 'updateAll') {
      this.modal.confirm('Do you want to update all data?', this.viewref, this.UpdateAllUnitPriceFail)
    }
    else if (type == 'updateTariffCode') {
      this.modal.confirm('Do you want to update on this data?', this.viewref, this.UpdateTariffCode)
    }
  }

  IsSelectRow(data: any) {
    this.isCanUpdate = true;
    this.fromData = data;
    this.params.PART_NO = this.fromData.PART_NO;
    if (!this.fromData.UNIT_PRICE_MASTER) {
      this.isCanUpdate = false;
    }
  }

  UpdateUnitPriceFail = () => {
    this.Http.post('SL', 'SNSQ022_UpdateUnitPriceFail', this.fromData)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Done.', this.viewref);
          this.SearchByCustomerCode();
          this.fromData = null;
          this.isCanUpdate = false;
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  UpdateAllUnitPriceFail = () => {
    var Data = this.tableData4.filter(value => value.UNIT_PRICE_MASTER != null);
    this.Http.post('SL', 'SNSQ022_UpdateAllUnitPriceFail', Data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Done.', this.viewref);
          this.SearchByCustomerCode();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  UpdateTariffCode = () => {
    this.Http.post('SL', 'SNSQ022_UpdateTariffCode', this.tableData5)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Process was completed.', this.viewref);
          this.SearchByCustomerCode();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  callback(data: any) {
    if (data == 'DONE') {
      this.SearchByCustomerCode();
    }
  }

  OpenSNSE01E() {
    this.SNSQ01E_UPLOAD.OpenDialog();
  }

  setRowClick(row: any) {
    this.dataOnClick = row;
    this.dataOnClick.FROM_DATE = this.params.FROM_DATE
    this.dataOnClick.TO_DATE = this.params.TO_DATE
    if (this.params.ORDER_NO) {
      this.dataOnClick.ORDER_NO = this.params.ORDER_NO;
    }
    if (this.params.ORDER_PART_NO) {
      this.dataOnClick.ORDER_PART_NO = this.params.ORDER_PART_NO;
    }
    if (this.params.ORDER_CLASS) {
      this.dataOnClick.ORDER_CLASS = this.params.ORDER_CLASS;
    }
  }

  compareRow(row1: any, row2: any) {
    return JSON.stringify(row1) === JSON.stringify(row2);
  }

}


