import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { FormControl } from '@angular/forms';
import * as moment from 'moment';

import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';


@Component({
    selector: 'snba007_s',
    templateUrl: './snba007_s.component.html',
    styleUrls: ['./snba007_s.component.css']
})



export class SNBA007_SComponent implements OnInit {


    constructor(
        private http: HttpService,
        private router: Router,
        private modal: ModalService,
      private viewRef: ViewContainerRef,
        private route: ActivatedRoute,
        private global: Globals
    ) {
    }

    private CurDate = new FormControl(new Date());
    private StartDate = new FormControl(new Date());
    private EndDate = new FormControl(new Date());
    private cDate = new FormControl(new Date());
    private inputCurDate = new FormControl(new Date());

    public formData: any = {};

    ngOnInit() {
        this.GetJobBatchID();
    }

    GetJobBatchID() {
        this.http.get("IC", "GetJobBatchID","SNPJ002")
            .subscribe(result => {
                console.log('this.result', result.Table[0]);
                this.formData = result.Table[0];

                this.inputCurDate = this.formData.CURRENT_DATE;
                console.log('this.formData', this.formData)
            })
    }


  SaveData() {
    this.modal.confirm("Are you sure to save this record?", this.viewRef,
      () => {

        this.http.post("IC", "SaveJobBatchID", JSON.stringify(this.formData))
          .subscribe(result => {
            if (result === "Done") {
              this.modal.info("Saved data successfully", this.viewRef);
              this.GetJobBatchID();
            }
          }, (err) => {
            console.log(err, 'err')
          })

      }, () => { })
    }

    BackToMain() {
        this.router.navigate(['/main']);
    }
 
    CurDateChange(v: any) {}
    StartDateChange(v: any) {}
    EndDateChange(v: any) {}


}
