import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { FormControl } from '@angular/forms';
import * as moment from 'moment';

import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';


@Component({
  selector: 'snba007_ic',
  templateUrl: './snba008.component.html',
  styleUrls: ['./snba008.component.css']
})



export class SNBA008Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) {

  }

  private CurDate = new FormControl(new Date());
  private StartDate = new FormControl(new Date());
  private EndDate = new FormControl(new Date());
  private cDate = new FormControl(new Date());
  private inputCurDate = new FormControl(new Date());

  public formData: any = {};


  ngOnInit() {

    // this.formData.CURRENT_DATE = null;
    //conDate = new FormControl(moment());
    //cDate = new FormControl(new Date());
    this.GetJobBatchID();
  }

  GetJobBatchID() {
    this.http.get("IC", "GetJobBatchID", "SNPJ010")
      .subscribe(result => {
        console.log('this.result', result.Table[0]);
        this.formData = result.Table[0];

        this.inputCurDate = this.formData.CURRENT_DATE;
        console.log('this.formData', this.formData)
      })
  }



  public BackToMain() {
    this.router.navigate(['/main']);
  }

  public ClearJob() {

    this.modal.confirm("Are you sure to clear job?", this.viewRef,
      () => {

        this.http.post("IC", "ClearJobBatchID", JSON.stringify(this.formData))
          .subscribe(result => {
            if (result === "Done") {
              this.modal.info("Clear job successfully", this.viewRef);
              this.GetJobBatchID();
            }
          }, (err) => {
            console.log(err, 'err')
          })

      }, () => { })


  }

  CurDateChange(v: any) { }
  StartDateChange(v: any) { }
  EndDateChange(v: any) { }

}
