import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';

@Component({
  selector: 'snse162',
  templateUrl: './snse162.component.html',
  styleUrls: ['./snse162.component.css']
})



export class SNSE162Component implements OnInit {


  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) {
  }
  public tabledata: any = [];
  public PROCESS_LOG: any = [];

  public params = {
    SOURCING_CODE: null,
    SOURCING_GROUP: null,
    VENDOR_CODE: null,
    ORIGIN_CODE: null,
    PFPM_REGIS_STATUS: null,
    WVL_REGIS_STATUS: null
  }

  ngOnInit() {

  }

  public ConfigSourcingCode: any = {
    ColName: "LOOK_UP_SOURCING_CODE",
    PlaceholderText: "Select Sourcing Code",
    SourceController: "IC",
    SourceMethodName: "SNSE162_getSourcingCode",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigVendorCode: any = {
    ColName: "LOOK_UP_VENDOR_NAME",
    PlaceholderText: "Select Vendor Code",
    SourceController: "IC",
    SourceMethodName: "SNSE162_getVendorCode",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public ConfigOriginCode: any = {
    ColName: "LOOK_UP_ORIGIN_CODE",
    PlaceholderText: "Select Origin Code",
    SourceController: "IC",
    SourceMethodName: "SNSE162_getOriginCode",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public Search() {
    this.tabledata = [];
    this.http.post("IC", "SNSE162_getSearch", this.params)
      .subscribe(res => {
        this.tabledata = res.Table;
      })
  }


  public ExportExcel() {
    this.http.Download("IC", "SNSE162_Export_Excel", JSON.stringify(this.tabledata))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.PROCESS_LOG.push('Export complete ' + this.tabledata.length + ' records.');
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  public WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSE162" + "_" + date_export.getFullYear() + "/" + (date_export.getMonth() + 1) + "/" + date_export.getDate() + ".csv";
    a.click();
  }

  public SetSourcingCode(values: any) {
    this.params.SOURCING_CODE = values.SOURCING_CODE;
  }
  public SetVendorCode(values: any, data: any) {
    data.VENDOR_CODE = values.VENDOR_CODE;
  }
  public SetOriginCode(values: any, data: any) {
    data.ORIGIN_CODE = values.ORIGIN_CODE;
  }
}
