
import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'SNM011P',
    templateUrl: 'SNM011P.component.html',
    styleUrls: ['SNM011P.component.css']
})

export class SNM011PComponent implements OnInit {
    constructor(
        private http: HttpService,
        private router: Router,
        private global: Globals,
        private modal: ModalService,
        private viewref: ViewContainerRef
    ) { }

    public PartCategory: string;
    public PartCategoryCode: string;
    public PartCategoryList: Array<any> = [];
    public FluctuationList: Array<any> = [];

    public PartCategoryLookup: any = {
        ColName: "LOOKUP_PART_CAT_NAME",
        PlaceholderText: "Select Part Category",
        MinLengthSearch: 0,
    }

    ngOnInit() {
        this.GetPartCategory();
    }

    GetPartCategory() {
        this.http.get("wPMS", "GetPartCategory")
            .subscribe(result => {
                this.PartCategoryList = result.Table;
            })
    }

    SetPartCategoryLookup(val) {
        this.PartCategory = val.LOOKUP_PART_CAT_NAME;
        this.PartCategoryCode = val.PART_CATEGORY;
    }

    SearchFluctuation() {
        this.FluctuationList = []
        this.http.get("IC", "SNM011P_GetDetail", this.PartCategoryCode)
            .subscribe(result => {
                this.FluctuationList = result.Table;
            })
    }
}