import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { FormControl, Validators } from '@angular/forms';
import { ModalService } from 'src/app/core/modal.service';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'snse034',
  templateUrl: './SNSE034.component.html',
  styleUrls: ['./SNSE034.component.css']
})



export class SNSE034Component implements OnInit {

  constructor(
    private Http: HttpService,
    private router: Router,
    private global: Globals,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public params: any = {};

  public TableData: any = [];
  public DataIsSelected: any = [];
  public isSelected: any = {};
  ngOnInit() {
  }

  public lookupCustomerCodeConfig: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE034_GetCustomerCode",
    NoOfShowRecords: 100,
    MinLengthSearch: 0,
    UpperCase: true
  }


  public SetSelectedCustomerCode(values: any) {
    this.params.CUSTOMER_CODE = values.CUSTOMER_CODE;
    this.params.CUSTOMER_NAME = values.CUSTOMER_NAME;
    this.params.BRANCH_CODE = values.BRANCH_CODE;
    this.params.BRANCH_NAME = values.BRANCH_NAME;
    this.Search();
  }


  Search = () => {
    this.TableData = [];
    this.Http.post('SL', 'SNSE034_getData', this.params)
      .subscribe(res => {
        this.TableData = res.Table;
      })
  }

  IsSelectRow(row) {
    this.isSelected = row;
  }


  ConfirmSave() {
    this.modal.confirm('Do you want to update on this data?', this.viewref, this.Save)
  }

  Save = () => {
    this.TableData.forEach((e) => {
      if (e.CONTAINER_NO != e.CONTAINER_NO_OLD) {
        this.DataIsSelected.push(e);
      }
    });
    this.Http.post('SL', 'SNSE034_Update', this.DataIsSelected)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Save data successfully.', this.viewref);
          this.Search();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }


}
