
import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef, Inject } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { FormControl } from '@angular/forms';
import * as moment from 'moment';

import { ModalService } from 'src/app/core/modal.service';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { DialogPoComponent } from '../../../components/shared/dialog-po/dialog-po.component';
import { SNSQ005_OnOrderComponent } from './Partail/SNSQ005_OnOrder.component'

@Component({
  selector: 'snsq005_001',
  templateUrl: './SNSQ005_001.component.html',
  styleUrls: ['./SNSQ005_001.component.css']
})

export class SNSQ005_001Component implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    public dialog: MatDialog,

    private viewRef: ViewContainerRef
  ) { }

  @ViewChild("ShowDetail", { static: false }) dialogDetail;

  public PageTitle: string;
  public info: any = {};
  public partData: any = {};
  public ExiseTax: any = {};
  public PartOption: any = {};
  public stockData: any = {};
  public dataList: any = [];
  public dataDetail: any = {};

  public dataListETP: any = [];
  public dataListBackOrder: any = [];
  public dataListChainPart: any = [];

  public dataListSuspTF: any = [];
  public dataListSusp: any = {};
  public dataListTF: any = {};

  private vendorETD: any = {};
  public findPO: any;
  public CustomerList: any;
  public tableData: any;
  public filter: any = [];
  public iActiveTab: number = 0;

  public dataDrilldown: any = [];

  public lookupConfig: any = {
    ColName: "LOOKUP_PART_VALUE",
    PlaceholderText: "Select Part",
    SourceController: "IC",
    SourceMethodName: "SNSQ005_GetPart",
    NoOfShowRecords: 50,
    UpperCase: true
  }

  ngOnInit() {
    this.partData.PART_NO = ''; //'402063HA0A'; //H210A3GFMA
    this.iActiveTab = 0;
  }

  public SetSelectedPart(value: any) {
    this.partData.PART_NO = value.PART_NO;

    this.GetDataTab1();
    this.SetActiveTab();
  }

  public TabChanged(event) {
    this.iActiveTab = event.index;
    this.SetActiveTab();
  }

  private SetActiveTab() {

    if (this.iActiveTab == 0) {

    } else if (this.iActiveTab == 1) {

    } else if (this.iActiveTab == 2) {
      this.GetDataTab3();
    } else if (this.iActiveTab == 3) {

    } else if (this.iActiveTab == 4) {
      this.GetDataTab5();
    } else if (this.iActiveTab == 5) {
      this.GetDataTab6();
    }

  }

  private GetDataTab1() {

    this.stockData = {};
    this.info = {};
    if (this.partData.PART_NO.length >= 3) {
      this.http.get("IC", "SNSQ005_GetPartInfo", this.partData.PART_NO)
        .subscribe(result => {
          this.partData = result.Table[0];
          this.stockData = result.Table1[0];
          this.info = result.Table2[0];
        })

      this.http.get("IC", "SNSQ005_GetPartInfo_G2", this.partData.PART_NO)
        .subscribe(result => {
          this.ExiseTax = result.Table[0] || {};
          this.PartOption = result.Table1[0] || {};
        })


    } else {

    }
  }

  private GetDataTab3() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G3", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListBackOrder = result.Table; // Tab 3 : Back order
      })
  }


  private GetDataTab5() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G5", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListETP = result.Table; // Tab 5 : ETP
      })

  }

  private GetDataTab6() {
    this.http.get("IC", "SNSQ005_GetPartInfo_G6", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListChainPart = result.Table; // Tab 6 : dataListChainPart
      })
  }


  public OpenSuspend() {
    this.dataListSuspTF = [];
    if (this.stockData.SUSPEND_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_SUS", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();

  }

  public OpenTransafer() {
    this.dataListSuspTF = [];
    if (this.stockData.TRANSFER_QTY == 0) {
      return;
    }
    this.http.get("IC", "SNSQ005_GetPartInfo_TF", this.partData.PART_NO)
      .subscribe(result => {
        this.dataListSuspTF = result.Table;
      })
    this.dialogDetail.OpenDialog();
  }

}
