import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from '../../../core/modal.service';
import { FormControl, Validators } from '@angular/forms';
import { Globals } from 'src/app/core/global';

@Component({
    selector: 'SNM016P',
    templateUrl: './SNM016P.component.html',
    styleUrls: ['./SNM016P.component.css']
})



export class SNM016PComponent implements OnInit {


    constructor(
        private http: HttpService,
        private router: Router,
        private modal: ModalService,
        private viewref: ViewContainerRef,
        private global : Globals
  
    ) { }
    @ViewChild("dialog", { static: false }) dialog: any;
    @ViewChild("dialog2", { static: false }) dialog2: any;
    public data: any = [];
    public opened: boolean;
    
    public Param : any = {};
    
    public ConfigRoute: any = {
        ColName: "LOOK_UP",
        ColValue: "",
        PlaceholderText: "Select Route",
        SourceController: "WH",
        SourceMethodName: "SNM016P_GetRoute",
        NoOfShowRecords: 30,
        MinLengthSearch : 1,
        UpperCase : false
    }

    public ParamsAdd: any = {
        ROUTE_CODE: null,
        ROUTE_NAME_EN: null,
        ROUTE_NAME_TH: null,
        
    }

    public ParamsEdit: any = {
        ROUTE_CODE: null,
        ROUTE_NAME_EN: null,
        ROUTE_NAME_TH: null,
        UPDATE_NAME_EN : null,
        LAST_UPD_DATE : null
    }

    public valid : boolean = false;
    public CategoryList :any = [];
    public RouteCodeControl = new FormControl('',[Validators.required])

    ngOnInit() {

    }

    openDialog() {
        this.dialog.OpenDialog()
    }



    Search() {
        this.data = []
        this.http.post("WH","SNM016P_GetRouteDetail",{ROUTE_CODE : this.Param.ROUTE_CODE})
        .subscribe(res =>{
            this.data = res.Table;        
        })

    }


    SaveAdd() {

        this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveAdd)

    }

    ConfirmSaveAdd = () => {

                this.http.post('WH', 'SNM016P_Insert', this.ParamsAdd)
                    .subscribe(res => {

                        console.log(res)
                        if (res.Table[0].STATUS == 'Done') {
                          this.modal.info('Transaction complete: applied and saved.', this.viewref);
                          if(this.data.length > 0){
                            this.Search();
                          }

                          this.ParamsAdd = this.global.ClearObject(this.ParamsAdd);
                          this.dialog.Close();                                 
                        } else if (res.Table[0].STATUS == 'Duplicate') {
                            this.modal.info('No change to save. Found duplicate record.', this.viewref);
                        }
                        else {
                            this.modal.warning(res.Table[0].MESSAGE, this.viewref);
                        }
                    })             
    }

    CancelAdd() {
        
        this.dialog.Close();
        //this.ClearData();

    }

    EditRow(data) {
        console.log(data)
       this.ParamsEdit = data
       this.dialog2.OpenDialog();
    }

    SaveEdit() {

        this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveEdit)
       
    }

    ConfirmSaveEdit = () => {

      this.http.post('WH', 'SNM016P_Update', this.ParamsEdit)
                .subscribe(res => {
                    if (res.Table[0].STATUS == 'Done') {
                      this.modal.info('Transaction complete: applied and saved.', this.viewref);
                      this.Search();
                      this.dialog2.Close();
                        
                    } else {
                        this.modal.warning(res.Table[0].MESSAGE, this.viewref);
                    }
                })  
    }

    Delete(data) {

        this.modal.confirm('Do you want to delete record?', this.viewref, () => this.ConfirmDelete(data))
    }

    ConfirmDelete = (data) => {

        this.http.post('WH', 'SNM016P_Delete', data)
            .subscribe(res => {
                if (res.Table[0].STATUS == 'Done') {
                    this.modal.info('Transaction complete: applied and saved.', this.viewref);    
                    this.Search();
                } else {
                    this.modal.warning(res.Table[0].MESSAGE, this.viewref);
                }
            })
   
    }


    CancelEdit() {
        this.dialog2.Close();
    }


    RouteCodeErrorMessage(){

      return  this.RouteCodeControl.hasError('required') ? 'Field must be entered' :''
          
    }
}

