import { Component, OnInit, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from '../../../core/modal.service';
import { FormControl, Validators } from '@angular/forms';

@Component({
    selector: 'snm026p',
    templateUrl: './SNM026P.component.html',
    styleUrls: ['./SNM026P.component.css']
})



export class SNM026PComponent implements OnInit {


    constructor(
        private http: HttpService,
        private router: Router,
        private modal: ModalService,
        private viewref: ViewContainerRef
  
    ) { }
    @ViewChild("dialog", { static: false }) dialog: any;
    @ViewChild("dialog2", { static: false }) dialog2: any;
    public data: any = [];
    public VENDOR_CODE: any = null;
    public VENDOR_NAME: any;
    public CategoryLits: any = [];
    public BranchList: any = [];
    public opened: boolean;
    
    public Param = {
        RACK_CODE: null,
        PART_CATEGORY: null,
        
    }

    public OilPoList = [{ ID: 'D', NAME: 'Daily' }, { ID: 'W', NAME: 'Weekly' }, { ID: 'M', NAME: 'Monthly' }]

    public ConfigRack: any = {
        ColName: "RACK_CODE",
        ColValue: "RACK_CODE",
        PlaceholderText: "Select Rack",
        SourceController: "WH",
        SourceMethodName: "SNM026P_GetRack",
        NoOfShowRecords: 30,
        MinLengthSearch : 1,
        UpperCase : false
    }


    public AddData: any = {
        RACK_CODE: null,
        PART_CATEGORY: null,
        RACK_GROUP_CODE: null,
       
    }

    public EditData: any = {
        RACK_CODE: null,
        PART_CATEGORY: null,
        RACK_GROUP_CODE: null,
      
    }
    public valid : boolean = false;
    public TableData: any = [];

    public CategoryList :any = [];

    public RackCodeControl = new FormControl('',[Validators.required])

    public PartCatControl = new FormControl('',[Validators.required])

    ngOnInit() {
        this.GetCat();
        
    }


    GetCat() {
        this.http.get('WH', 'SNM026P_GetPartCategory')
            .subscribe(res => {
                this.CategoryList = res.Table
            })
    }


    openDialog() {
       
        this.dialog.OpenDialog()
    }



    Search() {

        this.http.post("WH","SNM026P_GetData",this.Param)
        .subscribe(res =>{
           this.data = res.Table 
        })

    }


    SaveAdd() {

        this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveAdd)

    }

    ConfirmSaveAdd = () => {

                this.http.post('WH', 'SNM026P_Insert', this.AddData)
                    .subscribe(res => {

                        console.log(res)
                        if (res.Table[0].STATUS == 'Done') {
                          this.modal.info('Transaction complete: applied and saved.', this.viewref);
                          this.Search();
                          this.dialog.Close();
                          this.ClearData();
                                                       
                        } else if (res.Table[0].STATUS == 'Duplicate') {
                            this.modal.info('No change to save. Found duplicate record.', this.viewref);
                        }
                        else {
                            this.modal.warning(res.Table[0].MESSAGE, this.viewref);
                        }
                    })             
    }

    CancelAdd() {
        
        this.dialog.Close();
        //this.ClearData();

    }

    EditRow(data) {
        

       this.EditData.RACK_CODE = data.RACK_CODE
       this.EditData.PART_CATEGORY = data.PART_CATEGORY
       this.EditData.RACK_GROUP_CODE = data.RACK_GROUP_CODE

        this.dialog2.OpenDialog();
    }

    SaveEdit() {

        this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveEdit)
       
    }

    ConfirmSaveEdit = () => {

      this.http.post('WH', 'SNM026P_Update', this.EditData)
                .subscribe(res => {
                    if (res.Table[0].STATUS == 'Done') {
                      this.modal.info('Transaction complete: applied and saved.', this.viewref);
                      this.Search();
                      this.dialog2.Close();
                        
                    } else {
                        this.modal.warning('No change to save. Something went wrong.', this.viewref);
                    }
                })  
    }

    Delete(data) {

        this.modal.confirm('Do you want to delete record?', this.viewref, () =>{

            this.http.post('WH', 'SNM026P_Delete', data)
            .subscribe(res => {
                if (res.Table[0].STATUS == 'Done') {
                    this.modal.info('Transaction complete: applied and saved.', this.viewref);    
                    this.Search();
                } else {
                    this.modal.warning('No change to save. Something went wrong.', this.viewref);
                }
            })
        })
    }

    ConfirmDelete = () => {

       
   
    }


    CancelEdit() {
        this.dialog2.Close();
    }


    ClearData(){
        this.AddData.RACK_CODE = null
        this.AddData.RACK_GROUP_CODE = null
        this.AddData.PART_CATEGORY = null
        
    }

    RackCodeErrorMessage(){

      return  this.RackCodeControl.hasError('required') ? 'Field must be entered' :''
          
    }


    PartCatErrorMessage(){
        return  this.PartCatControl.hasError('required') ? 'Field must be entered' :''

    }

    


}

