import { Component, OnInit, ViewChild, ViewContainerRef, ElementRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';

@Component({
    selector: 'snm102p',
    templateUrl: './SNM102P.component.html',
    styleUrls: ['./SNM102P.component.css']
})



export class SNM102PComponent implements OnInit {


    constructor(
        private http: HttpService,
        private router: Router,
        private modal : ModalService,
        private viewref : ViewContainerRef
    ) { }
    
    @ViewChild('fileUpload',{static : false}) fileUpload: ElementRef;
    public tableData: any;
    public FileName : string = ''
    public formData = new FormData();
    public files : any;
    ngOnInit() {


    }

    
    OnFileSelect(fileInput : any) {
        console.log('xx',this.fileUpload)
        this.files = fileInput.target.files;
        this.FileName = this.files[0].name;

        this.formData = new FormData();
        this.formData.append('file', this.files[0]);

            this.http.postFile('WH', 'SNM102P_UploadandGet', this.formData)
                .subscribe(res => {
                    this.tableData = res.Table                              
                })
    }


    Save(){
        this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSave)
    }

    ConfirmSave = () => {
        let data = [];
        data = this.tableData.filter(x => x.RESULT == 'OK')
        

        if(data.length > 0){
            this.http.post("WH","SNM102P_Update",data)
            .subscribe(res =>{
                if(res == "DONE"){
                    this.modal.info('Transaction complete: ' +  data.length +  ' record applied and saved.', this.viewref);   

                }else{
                    this.modal.warning('No change to save. Something went wrong.', this.viewref);
                }
            })
        }else{
            this.modal.info("No data",this.viewref)
        }
      
    }

    Clear(){
        this.tableData = []
        this.FileName = ''
        this.fileUpload.nativeElement.value = null;
    }

}

