import { Component, OnInit} from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snpr029',
  templateUrl: './snpr029.component.html',
  styleUrls: ['./snpr029.component.css']
})



export class SNPR029Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private global : Globals
  ) { }

  public data: any = [];
  public SelectList: any;
  public CustomerList: any = [];

  public VendorConfig: any = {
    ColName: "VENDOR_TEXT",
    ColValue: "",
    PlaceholderText: "Select Vendor Code",
    SourceController: "IC",
    SourceMethodName: "SNPR019_FindFVendor",
    NoOfShowRecords: 50,
    MinLengthSearch: 2,
    UpperCase: true
  }
  
public InvoiceConfig: any = {
    ColName: "INVOICE_NO",
    ColValue: "INVOICE_NO",
    PlaceholderText: "Select Invoice No.",
    SourceController: "wPMS",
    SourceMethodName: "GetInvoice",
    NoOfShowRecords: 50,
    MinLengthSearch: 3
}

public ConfigPart: any = {
  ColName: "LOOKUP_PART",
  ColValue: "",
  PlaceholderText: "Select Part No.",
  SourceController: "WH",
  SourceMethodName: "SNPR029_GetPart",
  NoOfShowRecords: 30,
  MinLengthSearch: 5,
  UpperCase: true
}



public Params: any = {
  VENDOR_CODE: null,
  INVOICE_NO: null,
  VENDOR_NAME : null
};


  ngOnInit() {
    this.SelectList = [{ ID: 1, SELECT_CODE: "A001" }, { ID: 2, SELECT_CODE: "B002" }, { ID: 3, SELECT_CODE: "C003" }]
      let i = 0;

      while(i < 5){
        this.data.push({
          PART_NO: '',
          PART_NAME: '',
          LOCATION: '',
          QTY: '',
          PRN: '',
        }) 
        i++
      }
 
  }

  AddRecord(){
    this.data.push({
      PART_NAME: '',
      LOCATION: '',
      QTY: '',
      PRN: '',
    })

   this.data =  this.data.slice();
  }

  SelectedVendor(event){

    this.Params.VENDOR_CODE = event.VENDOR_CODE
    this.Params.VENDOR_NAME = event.VENDOR_NAME_TH
    console.log(event)
  }

  SelectedPart(data,event){
    data.PART_NO = event.PART_NO
    data.PART_NAME = event.PART_NAME_EN
    data.LOCATION = event.LOCATION_NO
    data.QTY = 1
    data.PRN = 1
    console.log(data)
    console.log(event)
  }

  OpenReport(){
    let data = []
    data = this.data.filter(x => x.PART_NO)

    if(data.length > 0){
      this.http.post('WH','SNPR029_INSERT',data)
      .subscribe(res =>{
        if(res){
          this.global.GoToReport("PMS_RPT_WH_SNPR029", 
          {  P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
             P_VENDOR_NAME: this.Params.VENDOR_NAME
          }
          );
        }
      })
    }else{

      this.global.GoToReport("PMS_RPT_WH_SNPR029", 
      {  P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
         P_VENDOR_NAME: this.Params.VENDOR_NAME
      }
      );
    }
 
  }

}

