import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from '../../../core/modal.service';



@Component({
  selector: 'snse157',
  templateUrl: './SNSE157.component.html',
  styleUrls: ['./SNSE157.component.css']
})



export class SNSE157Component implements OnInit {

  public Data: any = {
    COMPANY_CODE: null,
    WH_SHELVE: null,
    WH_RECEIVING: null,
    WH_ALLOCATE: null,
    WH_PICKING: null,
    TOTAL_WH: null,
    EXP_RECEIVING: null,
    EXP_PACKING: null,
    EXP_PRE_INV: null,
    EXP_BOOKING: null,
    EXP_INVOICE: null,
    EXP_LOADING: null,
    TOTAL_EXP: null,
    TOTAL_ALL: null,
    CREATE_BY: null,
    CREATE_DATE: null,
    UPDATE_BY_NAME: null,
    LAST_UPD_DATE: null,
  };

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
  ) { }

  @ViewChild("dialogMain", { static: false }) dialogMain: any;

  ngOnInit() {
    this.getData()
  }

  getData() {
    this.http.get('WH', 'SNSE157_GetData')
      .subscribe(res => {
        this.Data = res.Table[0];
      })
  }

  calculateTotal() {
    this.Data.TOTAL_WH = this.Data.WH_SHELVE + this.Data.WH_RECEIVING + this.Data.WH_ALLOCATE + this.Data.WH_PICKING
    this.Data.TOTAL_EXP = this.Data.EXP_RECEIVING + this.Data.EXP_PACKING + this.Data.EXP_PRE_INV + this.Data.EXP_BOOKING + this.Data.EXP_INVOICE + this.Data.EXP_LOADING
    this.Data.TOTAL_ALL = this.Data.TOTAL_WH + this.Data.TOTAL_EXP
  }

  Update() {
    this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmUpdate)
  }

  ConfirmUpdate = () => {
    this.http.post('WH', 'SNSE157_UpdateData', this.Data)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'DONE') {
          this.modal.info('Update successful.', this.viewref);
          this.getData()
          this.dialogMain.Close();
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }

  CancelAdd() {
    this.dialogMain.Close();
  }
}

